// Current version - this is simply incremented for every update
var UI_VERSION = 7;

var usePNGHack = true;
var blankImage = "imgs/pix.gif";

function pngHack() {
    // Assume we're using IE until proven that we aren't (filters aren't found)
    if (document.images) {
	for (var i = 0; i < document.images.length; i++) {
	    if (document.images[i].filters) {
		var src = document.images[i].src;
		if (src.length > 4) {
		    if (src.substring(src.length - 4).toLowerCase() == ".png") {
			// do the PNG hack
			document.images[i].src = blankImage;
			document.images[i].style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='" +
                                     src + "',sizingMethod='scale')";
		    }
		}
	    } else {
		// Not IE: no filters
		usePNGHack = false;
		return;
	    }
	}
    } else {
	usePNGHack = false;
    }
}

var cssRules = new Object();

function applyCSSClass(doc, element, cssClass) {
    if (usePNGHack) {
	var style = cssRules[cssClass];
	if (style == null) {
	    var name = "." + cssClass;
	    // find the rules
	    var i, j;
	    for (i = 0; i < doc.styleSheets.length; i++) {
		for (j = 0; j < doc.styleSheets[i].rules.length; j++) {
		    if (doc.styleSheets[i].rules[j].selectorText == name) {
			style = doc.styleSheets[i].rules[j].style;
			cssRules[cssClass] = style;
		    }
		}
	    }
	}
	element.style.cssText = style.cssText;
    } else {
	element.setAttribute("class", cssClass);
    }
}

function skillChainSort(a, b) {
    // Sort first by chain...
    if (a.chain != b.chain) {
	// Chains with fewer elements go first
	if (a.chain.chainElement4 == null && b.chain.chainElement4 != null)
	    return -1;
	if (a.chain.chainElement4 != null && b.chain.chainElement4 == null)
	    return 1;
	if (a.chain.chainElement2 == null && b.chain.chainElement2 != null)
	    return -1;
	if (a.chain.chainElement2 != null && b.chain.chainElement2 == null)
	    return 1;
	return a.chain.name < b.chain.name ? -1 : (a.chain.name == b.chain.name ? 0 : 1);
    } else {
	// then by weapon skill
	var aSkill = a.fromSkill, bSkill = b.fromSkill;
	if (aSkill == bSkill) {
	    aSkill = a.toSkill;
	    bSkill = b.toSkill;
	}
	return aSkill.name < bSkill.name ? -1 : (aSkill.name == bSkill.name ? 0 : 1);
    }
}

function createElementIcon(doc, element) {
    var img = doc.createElement("img");
    if (usePNGHack) {
	img.src = blankImage;
	img.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src='imgs/" +
                                     element.icon + ".png',sizingMethod='scale')"
    } else {
	img.src = "imgs/" + element.icon + ".png";
    }
    img.style.width = "16px";
    img.style.height = "16px";
    img.style.border = "none";
    img.style.valign = "middle";
    img.setAttribute("alt", element.name);
    return img;
}

function createWeaponSkillIcons(doc, parent, skill) {
    if (skill.element != null)
	parent.appendChild(createElementIcon(doc, skill.element));
    if (skill.element2 != null)
	parent.appendChild(createElementIcon(doc, skill.element2));
    if (skill.element3 != null)
	parent.appendChild(createElementIcon(doc, skill.element3));
}

function getPosition(element) {
    var point;
    if (element.offsetParent) {
	point = getPosition(element.offsetParent);
    } else {
	point = new Object();
	point.x = 0;
	point.y = 0;
    }
    point.x += element.offsetLeft;
    point.y += element.offsetTop;
    return point;
}

function hidePopupWeapon(weapon) {
    if (weapon.popup != null) {
	weapon.popup.style.display = "none";
    }
}

function popupWeapon(event, weapon, parent) {
    if (weapon.popup == null) {
	var popup = document.createElement("div");
	weapon.popup = popup;
	applyCSSClass(document, popup, "Popup");
	var popupTitle = document.createElement("div");
	applyCSSClass(document, popupTitle, "PopupTitle");
	popupTitle.appendChild(document.createTextNode(weapon.name));
	popup.appendChild(popupTitle);
	var span = document.createElement("span");
	span.style.fontWeight = "bold";
	span.appendChild(document.createTextNode("EX: "));
	popup.appendChild(span);
	var str = "";
	var i;
	if (weapon.ex == null || weapon.ex.length == 0) {
	    str = getLocalString("none");
	} else {
	    for (i = 0; i < weapon.ex.length; i++) {
		if (i > 0)
		    str += ", ";
		str += weapon.ex[i].name;
	    }
	}
	popup.appendChild(document.createTextNode(str));
	popup.appendChild(document.createElement("br"));
	span = document.createElement("span");
	span.style.fontWeight = "bold";
	span.appendChild(document.createTextNode("SP: "));
	popup.appendChild(span);
	str = "";
	if (weapon.sp == null || weapon.sp.length == 0) {
	    str = getLocalString("none");
	} else {
	    for (i = 0; i < weapon.sp.length; i++) {
		if (i > 0)
		    str += ", ";
		str += weapon.sp[i].name;
	    }
	}
	popup.appendChild(document.createTextNode(str));
	popup.appendChild(document.createElement("br"));
	span = document.createElement("div");
	span.style.fontWeight = "bold";
	span.style.marginTop = "5pt";
	span.appendChild(document.createTextNode(getLocalString("skills")));
	popup.appendChild(span);
	var table = document.createElement("table");
	var tbody = document.createElement("tbody");
	table.appendChild(tbody);
	var tr, td;
	for (i = 0; i < weapon.skills.length; i++) {
	    tr = document.createElement("tr");
	    tbody.appendChild(tr);
	    td = document.createElement("td");
	    tr.appendChild(td);
	    td.style.textAlign="right";
	    td.appendChild(document.createTextNode(weapon.skills[i].level));
	    td = document.createElement("td");
	    tr.appendChild(td);
	    createWeaponSkillIcons(document, td, weapon.skills[i]);
	    td = document.createElement("td");
	    tr.appendChild(td);
	    var name = weapon.skills[i].name;
	    if (weapon.skills[i].flags == WS_EX) {
		name = name + " [EX]";
	    } else if (weapon.skills[i].flags == WS_SP) {
		name = name + " [SP]";
	    }
	    td.appendChild(document.createTextNode(name));
	}
	popup.appendChild(table);
	popup.style.position = "absolute";
	document.body.appendChild(popup);
    }
    positionPopup(parent, weapon.popup, event);
    weapon.popup.style.display = "block";
}

function hidePopupWeaponSkill(element) {
    if (element.skill.popup != null) {
	element.skill.popup.style.display = "none";
    }
}

// Fake sprintf function - replaces "%s" with elements from the input
function sprintf(str, e1, e2) {
    var i = str.indexOf("%s");
    var offset = 0;
    if (i >= 0) {
	str = str.substring(0, i) + e1 + str.substring(i+2);
	offset = i + e1.length;
	i = str.indexOf("%s", offset);
	if (i >= 0) {
	    str = str.substring(0, i) + e2 + str.substring(i+2);
	}
    }
    return str;
}

function popupWeaponSkill(event, element) {
    var popup = element.skill.popup;
    if (popup == null) {
	/* The following is only useful with the HTA app:
	var doc = element.ownerDocument;
	if (doc == null) // no popup, then
	    return;
	For now, just stick with the main document
	*/
	var doc = document;
	var skill = element.skill;
	popup = doc.createElement("div");
	element.skill.popup = popup;
	applyCSSClass(doc, popup, "Popup");
	var popupTitle = doc.createElement("div");
	applyCSSClass(doc, popupTitle, "PopupTitle");
	popup.style.position = "absolute";
	popup.style.width = "216pt";
	createWeaponSkillIcons(doc, popupTitle, skill);
	popupTitle.appendChild(doc.createTextNode(skill.name));
	popup.appendChild(popupTitle);
	popup.appendChild(doc.createTextNode(sprintf(getLocalString("skill"), skill.weapon.name)));
	popup.appendChild(doc.createElement("br"));
	popup.appendChild(doc.createTextNode(sprintf(getLocalString("requiredskill"), skill.level)));
	popup.appendChild(doc.createElement("br"));
	if (skill.flags == WS_NORMAL) {
	    popup.appendChild(doc.createElement("hr"));
	    popup.appendChild(doc.createTextNode(sprintf(getLocalString("anyjob"), skill.weapon.name)));
	} else if (skill.flags == WS_EX) {
	    var str = "EX: ";
	    var i;
	    if (skill.weapon.ex == null || skill.weapon.ex.length == 0) {
		str = getLocalString("nojob");
	    } else {
		for (i = 0; i < skill.weapon.ex.length; i++) {
		    if (i > 0)
			str += ", ";
		    str += skill.weapon.ex[i].name;
		}
	    }
	    popup.appendChild(doc.createTextNode(str));
	    popup.appendChild(doc.createElement("hr"));
	    popup.appendChild(doc.createTextNode((skill.weapon.ex != null && skill.weapon.ex.length == 1 ?
			getLocalString("exjob") :
			getLocalString("exjobs"))));
	} else if (skill.flags == WS_SP) {
	    var str = "SP: ";
	    var i;
	    if (skill.weapon.sp == null || skill.weapon.sp.length == 0) {
		str = getLocalString("nojob");
	    } else {
		for (i = 0; i < skill.weapon.sp.length; i++) {
		    if (i > 0)
			str += ", ";
		    str += skill.weapon.sp[i].name;
		}
	    }
	    popup.appendChild(doc.createTextNode(str));
	    popup.appendChild(doc.createElement("hr"));
	    popup.appendChild(doc.createTextNode(
		    (skill.weapon.sp != null && skill.weapon.sp.length == 1 ?
			getLocalString("spjob") :
			getLocalString("spjobs"))));
	}
	doc.body.appendChild(popup);
    }
    positionPopup(element, popup, event);
    popup.style.display = "block";
}

function showPopup(event, parent, text, title) {
    var popup = parent.popup;
    if (popup == null) {
	popup = document.createElement("div");
	parent.popup = popup;
	applyCSSClass(document, popup, "Popup");
	popup.style.position = "absolute";
	popup.style.left = "0px";
	popup.style.top = "0px";
	popup.style.width = "216pt";
	if (title != null) {
	    var popupTitle = document.createElement("div");
	    applyCSSClass(document, popupTitle, "PopupTitle");
	    popupTitle.appendChild(document.createTextNode(title));
	    popup.appendChild(popupTitle);
	}
	var lines = text.split("\n");
	for (var i = 0; i < lines.length; i++) {
	    if (i > 0)
		popup.appendChild(document.createElement("br"));
	    if (usePNGHack) {
		var index = lines[i].indexOf("\u27a8");
		while (index >= 0) {
		    popup.appendChild(document.createTextNode(lines[i].substring(0, index)));
		    var arrow = document.createElement("span");
		    arrow.style.fontFamily = "\"Wingdings 3\"";
		    arrow.appendChild(document.createTextNode("\xc6"));
		    popup.appendChild(arrow);
		    lines[i] = lines[i].substring(index + 1);
		    index = lines[i].indexOf("\u27a8")
		}
	    }
	    popup.appendChild(document.createTextNode(lines[i]));
	}
	document.body.appendChild(popup);
    }
    positionPopup(parent, popup, event);
    popup.style.display = "block";
}

function hidePopup(parent) {
    var popup = parent.popup;
    if (popup != null) {
	parent.popup.style.display = "none";
    }
}

function positionPopup(parent, popup, event) {
    var pt = getPosition(parent);
    // Make sure we won't scroll off the current viewport with this popup
    // MUCH help on figuring out how to determine viewport settings
    // from <http://www.quirksmode.org/viewport/compatibility.html>
    // Thanks tons!
    if (popup.height == null) {
	// haven't calculated this yet, do it now
	popup.style.left = "0px";
	popup.style.top = "0px";
	popup.style.display = "block";
	popup.height = popup.offsetHeight;
    }
    var height = popup.height;
    var viewY;
    if (window.pageYOffset) { // Opera, Moz
	viewY = window.pageYOffset;
    } else if (document.documentElement && document.documentElement.scrollTop) { // IE 6 Strict
	viewY = document.documentElement.scrollTop;
    } else if (document.body) { // All other IEs
	viewY = document.body.scrollTop;
    } else { // Uh... randomly choose something
	viewY = 0;
    }
    var viewHeight;
    if (window.innerHeight) { // Opera, Moz
	viewHeight = window.innerHeight;
    } else if (document.documentElement && document.documentElement.clientHeight) { // IE 6 Strict (we are)
	viewHeight = document.documentElement.clientHeight;
    } else if (document.body) { // All other IEs
	viewHeight = document.body.clientHeight;
    } else { // Uh...
	// randomly choose something
	viewHeight = 480;
    }
    var popupX = event.clientX + 10;
    var popupY = pt.y + parent.offsetHeight;
    if (popupY + height >= viewY + viewHeight) {
	popupY = viewY + viewHeight - height;
    }
    popup.style.left = popupX + "px";
    popup.style.top = popupY + "px";
}

function addChain(doc, parent, skill) {
    var span = doc.createElement("span");
    createWeaponSkillIcons(doc, span, skill);
    var name = skill.name;
    if (skill.flags == WS_EX) {
	name = name + " [EX]";
    } else if (skill.flags == WS_SP) {
	name = name + " [SP]";
    }
    span.appendChild(doc.createTextNode(name));
    span.skill = skill;
    span.onmouseover = function(e) { popupWeaponSkill((e == null ? event : e), this) };
    span.onmouseout = function() { hidePopupWeaponSkill(this) };
    parent.appendChild(span);
}

var selectMode = "Members";

function skillChange() {
    // count the number of boxes currently checked -- if 0, disable
    // the button.  If 1, disable (and check) "chain with own" box
    var weaponCount = 0;
    with (document.forms.skillchains) {
	if (selectMode == "Checkbox") {
	    if (archery.checked) {
		weaponCount++;
	    }
	    if (axe.checked) {
		weaponCount++;
	    }
	    if (club.checked) {
		weaponCount++;
	    }
	    if (dagger.checked) {
		weaponCount++;
	    }
	    if (greataxe.checked) {
		weaponCount++;
	    }
	    if (greatkatana.checked) {
		weaponCount++;
	    }
	    if (greatsword.checked) {
		weaponCount++;
	    }
	    if (handtohand.checked) {
		weaponCount++;
	    }
	    if (katana.checked) {
		weaponCount++;
	    }
	    if (marksmanship.checked) {
		weaponCount++;
	    }
	    if (scythe.checked) {
		weaponCount++;
	    }
	    if (spear.checked) {
		weaponCount++;
	    }
	    if (staff.checked) {
		weaponCount++;
	    }
	    if (sword.checked) {
		weaponCount++;
	    }
	} else {
	    for (var i = 1; i <= 6; i++) {
		var wep = eval(document.forms.skillchains["member" + i].value);
		if (wep != null)
		    weaponCount++;
	    }
	}
	if (weaponCount == 0) {
	    // disable the button
	    showscbutton.disabled = true;
	    chainwithown.disabled = true;
	} else if (weaponCount == 1) {
	    // Check "chain with own" and disable it
	    chainwithown.oldChecked = chainwithown.checked;
	    chainwithown.checked = true;
	    chainwithown.disabled = true;
	    showscbutton.disabled = false;
	} else {
	    // Reset "chain with own" and enable it
	    if (chainwithown.oldChecked != null) {
		chainwithown.checked = chainwithown.oldChecked;
	    }
	    chainwithown.disabled = false;
	    showscbutton.disabled = false;
	}
    }
}

var showChainsInNewWindow = false;

function showChains() {
    // Create a list of weapons available:
    var weapons = new Array();
    var maxLevel = 500;
    with (document.forms.skillchains) {
	showscbutton.disabled = true;
	var ownChain = false;
	if (selectMode == "Checkbox") {
	    if (archery.checked) {
		weapons.push(ARCHERY);
	    }
	    if (axe.checked) {
		weapons.push(AXE);
	    }
	    if (club.checked) {
		weapons.push(CLUB);
	    }
	    if (dagger.checked) {
		weapons.push(DAGGER);
	    }
	    if (greataxe.checked) {
		weapons.push(GREAT_AXE);
	    }
	    if (greatkatana.checked) {
		weapons.push(GREAT_KATANA);
	    }
	    if (greatsword.checked) {
		weapons.push(GREAT_SWORD);
	    }
	    if (handtohand.checked) {
		weapons.push(HAND_TO_HAND);
	    }
	    if (katana.checked) {
		weapons.push(KATANA);
	    }
	    if (marksmanship.checked) {
		weapons.push(MARKSMANSHIP);
	    }
	    if (scythe.checked) {
		weapons.push(SCYTHE);
	    }
	    if (spear.checked) {
		weapons.push(SPEAR);
	    }
	    if (staff.checked) {
		weapons.push(STAFF);
	    }
	    if (sword.checked) {
		weapons.push(SWORD);
	    }
	    ownChain = chainwithown.checked;
	} else {
	    for (var i = 1; i <= 6; i++) {
		var wep = eval(document.forms.skillchains["member" + i].value);
		if (wep != null) {
		    weapons.push(wep);
		}
	    }
	    ownChain = false; // never chain with yourself!
	}
	maxLevel = parseInt(skilllevel.value);
	if (maxLevel < 10 || isNaN(maxLevel)) {
	    maxLevel = 10;
	    skilllevel.value = maxLevel;
	}
	window.status = "Working, please wait...";
	// Start looking through the weapons we have available
	var i, j, k;
	var len = weapons.length;
	var fullLen = len * len;
	var skillChains = new Array();
	for (i = 0; i < len; i++) {
	    for (j = 0; j < len; j++) {
		if (!ownChain && i == j)
		    continue;
		window.status = sprintf(getLocalString("working.find"), Math.floor(i * len * 100 / fullLen));
		skillChains = skillChains.concat(weapons[i].findChains(weapons[j], maxLevel));
	    }
	}
	window.status = getLocalString("working.sorting");
	skillChains.sort(skillChainSort);
	window.status = getLocalString("working.displaying");
	var curChain = null;
	var chainsPanel;
	var chainsDiv;
	var doc;
	var chainList = "";
	for (i = 0; i < len; i++) {
	    if (i > 0) {
		chainList += ", ";
	    }
	    chainList += weapons[i].name;
	}
	var chainsTitle = sprintf(getLocalString("chainstitle"), chainList, maxLevel);
	if (showChainsInNewWindow) {
	    if (skillChains.length == 0) {
		alert(getLocalString("no.chains.found"));
		return;
	    }
	    // Show a new window
	    var nWindow = window.open("", "", "directories=no,height=512,width=400,location=no,menubar=no,resizable=yes,scrollbars=yes,status=no,titlebar=yes,toolbar=no");
	    with (nWindow.document) {
		write("<html><head><title>");
		write(chainsTitle);
		writeln("</title>");
		writeln("<HTA:APPLICATION ID=\"renkei_skills\"");
		writeln("APPLICATIONNAME=\"RenkeiToolSkills\" BORDER=\"thick\" CAPTION=\"yes\"");
		writeln("ICON=\"imgs/renkei.ico\" INNERBORDER=\"no\" SCROLL=\"no\"");
		writeln("SHOWINTASKBAR=\"yes\" SINGLEINSTANCE=\"no\" SYSMENU=\"yes\"");
		writeln("WINDOWSTATE=\"normal\"></HTA:APPLICATION>");
		writeln("<link rel=\"stylesheet\" type=\"text/css\" href=\"skillchains.css\">");
		writeln("<meta http-equiv=\"Content-Type\" content=\"application/hta; charset=utf-8\">");
		writeln("<script type=\"text/javascript\" src=\"" + getLocalString("languageurl") + "\"></script>");
		writeln("<script type=\"text/javascript\" src=\"skillchains.js\"></script>");
		writeln("<script type=\"text/javascript\" src=\"skillchains-ui.js\"></script>");
		write("</head><body><div class=\"Box\"><div class=\"BoxTitle\">");
		write(chainsTitle);
		writeln("</div><div class=\"BoxContent\" id=\"chainsPanel\"></div></div></body></html>");
		close();
		chainsPanel = getElementById("chainsPanel");
		alert(chainsPanel);
	    }
	    doc = nWindow.document;
	} else {
	    chainsPanel = document.getElementById("chainsPanel");
	    doc = document;
	}
	if (chainsPanel.childNodes.length > 0) {
	    // remove any items currently on the chains div (starting from the end and working back)
	    for (i = chainsPanel.childNodes.length; i > 0; i--) {
		chainsPanel.removeChild(chainsPanel.childNodes.item(i-1));
	    }
	}
	chainsDiv = doc.createElement("div");
	var div;
	// since multiple chains are simply ignored on display, count them
	// separately from the length
	var chainCount = 0;
	if (skillChains.length == 0) {
	    chainsDiv.appendChild(doc.createTextNode(getLocalString("no.chains.found")));
	} else {
	    for (i = 0; i < skillChains.length; i++) {
		// Make sure we're not displaying the previous chain again
		if (i > 0 && skillChains[i].toSkill == skillChains[i-1].toSkill && skillChains[i].fromSkill == skillChains[i-1].fromSkill) {
		    continue;
		}
		chainCount++;
		if (curChain != skillChains[i].chain) {
		    curChain = skillChains[i].chain;
		    // Create a new header.
		    div = doc.createElement("div");
		    applyCSSClass(doc, div, "chain-header");
		    div.appendChild(doc.createTextNode(curChain.name));
		    div.appendChild(createElementIcon(doc, curChain.chainElement1));
		    if (curChain.chainElement2 != null) {
			div.appendChild(createElementIcon(doc, curChain.chainElement2));
		    }
		    if (curChain.chainElement3 != null) {
			div.appendChild(createElementIcon(doc, curChain.chainElement3));
		    }
		    if (curChain.chainElement4 != null) {
			div.appendChild(createElementIcon(doc, curChain.chainElement4));
		    }
		    chainsDiv.appendChild(div);
		}
		// Display the chain
		div = doc.createElement("div");
		applyCSSClass(doc, div, "chain");
		addChain(doc, div, skillChains[i].fromSkill);
		if (usePNGHack) {
		    // probably doesn't do Unicode if we're working around IE
		    div.appendChild(doc.createTextNode(" "));
		    var arrow = doc.createElement("span");
		    arrow.style.fontFamily = "\"Wingdings 3\"";
		    arrow.appendChild(doc.createTextNode("\xc6"));
		    div.appendChild(arrow);
		    div.appendChild(doc.createTextNode(" "));
		} else {
		    div.appendChild(doc.createTextNode(" \u27a8 "));
		}
		addChain(doc, div, skillChains[i].toSkill);
		chainsDiv.appendChild(div);
	    }
	}
	chainsPanel.appendChild(chainsDiv);
	window.status = sprintf(getLocalString("skills.found"), chainCount);
	showscbutton.disabled = false;
    }
}

function changeTab(tabName, deadTabName) {
    applyCSSClass(document, document.getElementById(tabName + "Tab"), "TabActive");
    applyCSSClass(document, document.getElementById(deadTabName + "Tab"), "TabInactive");
    document.getElementById(tabName + "TabContent").style.display = 'block';
    document.getElementById(deadTabName + "TabContent").style.display = 'none';
    selectMode = tabName;
    skillChange(); // since the select mode changed
}
